<template>
  <div class="q-pa-sm">
    <q-banner class="bg-warning text-white q-my-sm" rounded>
      Pagination/Sort doesnt work, because SWAPI works with "page" param and I
      am lazy to implement it
    </q-banner>
    <q-table
      :data="planets"
      :columns="columns"
      row-key="name"
      :pagination.sync="pagination"
      :loading="loading"
      @request="onRequest"
    >
      <template v-slot:body-cell-actions="props">
        <q-td class="text-right">
          <q-btn
            dense
            flat
            text-color="primary"
            label="detail"
            :to="props.value"
          />
        </q-td>
      </template>
    </q-table>
    <ErrorBanner v-if="error" :error="error" />
  </div>
</template>

<script>
import ErrorBanner from 'src/components/ErrorBanner'

export default {
  name: 'PlanetsList',
  components: {
    ErrorBanner,
  },
  props: {
    planets: {
      type: Array,
      required: true,
    },
    loading: {
      type: Boolean,
      required: true,
    },
    count: {
      type: Number,
      required: true,
    },
    error: {
      default: null,
    },
  },
  data() {
    return {
      filter: '',
      neco: '',
      columns: [
        {
          name: 'name',
          required: true,
          label: 'Name',
          align: 'left',
          field: row => row.name,
          format: val => `${val}`,
          sortable: true,
        },
        {
          name: 'actions',
          label: 'Actions',
          align: 'right',
          field: row => {
            const brokenUrl = row.url.split('/').filter(s => !!s)
            const id = brokenUrl[brokenUrl.length - 1]
            return `/planets/${id}`
          },
        },
      ],
    }
  },
  computed: {
    pagination: {
      get() {
        return this.$store.getters['planets/planetsPagination']
      },
      set(value) {
        this.$store.commit('planets/SET_PLANETS_PAGINATION', value)
      },
    },
  },
  methods: {
    onRequest(props) {
      this.pagination = props.pagination
      this.$store.dispatch('planets/getPlanetsList')
    },
  },
}
</script>
